#ifndef _connexe
#define _connexe

#include <interval/interval.hpp>

#include "expression.h"
#include "domain.h"
#include "map.h"
#include "sivia.h"



using namespace std; 
typedef filib::interval<double,filib::native_switched,filib::i_mode_extended> interval;


class connexe
{
 private:
  expression f;
  map <string,expression> gradient; 

  expression df_x_minus_s; 

  interval gradient_evalue(domain x, domain partial_x);

 public:
  connexe(expression _f);
  bool star_shaped (domain x);
   
};


#endif
 
