#ifndef __NODE__
#define __NODE__

#include <iostream>
#include <sstream>
#include <stdlib.h>
#include <vector>
#include <set>
#include <map>

#include <string>
#include <fstream>

class Node
{
public:
char Code;
//char * text;
char Name[20];
int Indice;
int Left_son;
int Right_son;
int Father;
double Valeur;
std::string symbole;
Node(char c,int l,int r) {Father=-1; Code=c; Left_son=l; Right_son=r;};
Node() {Father=-1; Code=0; Left_son=-1; Right_son=-1;};

std::string ToDot() {
  std::stringstream StrStream;
  std::string result;
  if 
     ((Code=='+') 
     or (Code=='*')
     or (Code=='/') 
     or (Code=='-'))
    {
      StrStream <<  Indice << " [label=\"" << Code << "\"] ; \n"  ;
      result = StrStream.str();} 
  else if  (Code=='C')
    {
      StrStream <<  Indice << " [label=\"" << "cos" << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='r')
    {
      StrStream <<  Indice << " [label=\"" << Valeur << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='P') 
    {
      StrStream <<  Indice << " [label=\"" << "power" << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='S') 
    {
      StrStream <<  Indice << " [label=\"" << "sin" << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='h') 
    {
      StrStream <<  Indice << " [label=\"" << "cosh" << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='i') 
    {
      StrStream <<  Indice << " [label=\"" << "sinh" << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='T') 
    {
      StrStream <<  Indice << " [label=\"" << "tan" << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='A') 
    {
      StrStream <<  Indice << " [label=\"" << "arctan" << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='E') 
    {
      StrStream <<  Indice << " [label=\"" << "exp" << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='L') 
    {
      StrStream <<  Indice << " [label=\"" << "ln" << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='R') 
    {
      StrStream <<  Indice << " [label=\"" << "sqrt" << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='2') 
    {
      StrStream <<  Indice << " [label=\"" << "sqr" << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='N')  
    {
      StrStream <<  Indice << " [label=\"" << "-" << "\"] ; \n"  ;
      result = StrStream.str();} 
     else if (Code=='V')  
    {
      StrStream <<  Indice << " [label=\"" << symbole << "\"] ; \n"  ;
      result = StrStream.str();} 
  return result;
 };
};

#define YYSTYPE Node

//extern YYSTYPE yylval;        // Cette variable est dclare dans le fichier parser.c
#endif
