#include "iboolean.h"
#include "mesh.h"
#include "sivia.h"


#include "SDL.h"
#include "SDL_opengl.h"


#ifndef _resultat_
#define _resultat_

 

class resultat 
{
public :
  mesh mesH; 
  mesh boundary; 

  vector <iboolean> one_to_one; 
  vector <iboolean> one_to_one_boundary; 
  vector <bool> star_shaped; 

  void out();
  void dessine();
  void dessine(int );
  void dessine_bord();
  void dessine_bord(int );
  void dessine_image(int );
  void dessine_contre_image_d_image(int i);
  void dessine_cc_contre_image_d_image(int i);

  void dessine_fr_cc_contre_image_d_image(int i);
  void dessine_contre_image_du_bord(int i);
  void dessine_contre_image_du_bord();

  void dessine_cc_contre_image_du_bord(int i);
  void dessine_fr_cc_contre_image_du_bord(int i);

  void dessine_contre_image_de_singularite(int i);
  void dessine_contre_image_de_singularite();

  void dessine_L_cur();

  vector < pair < domain , domain  > > L_cur ; 

  vector <int> singular_curve;
  vector <int> pure_singular_curve;

  vector < vector <int> > contre_image_de_singular;

  vector <domain> image;
  vector <domain> image_boundary;

  vector < vector <int> > contre_image_d_image;
  vector < vector <int> > contre_image_du_bord;

  vector < vector < vector <int> > >  composante_connexe_contre_image_d_image;
  vector < vector < vector <int> > >  fr_composante_connexe_contre_image_d_image;

  vector < vector < vector <int> > >  composante_connexe_contre_image_du_bord;
  vector < vector < vector <int> > >  fr_composante_connexe_contre_image_du_bord;


  vector < bool > contre_image_de_bord;
  vector < vector < bool > > newton;

  // point fronce - cas numéro 1 de l'article
  void dessine_cusp();
  void dessine_cusp_v(double );
  vector < domain > cusp_v;
  vector < pair < domain, int> > cusp;

  // singular_singular - cas numéro 2 de l'article
  vector < pair <domain , domain > > singular_singular_v;
  void dessine_singular_singular_v();

  // boundary_boundary - cas numéro 3 de l'article
  vector < pair < domain , domain  > > boundary_boundary_v;
  vector < pair < pair <domain , domain >, int > > boundary_boundary;
  void dessine_boundary_boundary_v( mesh m );
  void dessine_boundary_boundary();

  // singular_boundary - cas numéro 4 de l'article
  vector < pair < domain , domain  > > singular_boundary_v;
  vector < pair < pair <domain , domain >, int > > singular_boundary;
  void dessine_singular_boundary();
  void dessine_singular_boundary_v(double);



  vector <domain> courbe_singuliere;
  void dessine_courbe_singuliere();



};


#endif
 
